<?
require_once(_XE_PATH_."/modules/member/member.admin.view.php");

class ezmemberAdminView extends memberAdminView {
	
	function init(){
		// setup template path (board admin panel templates is resided in the tpl folder)
		$template_path = sprintf("%stpl/",$this->module_path);
		$this->setTemplatePath($template_path);

		// Check for license has agreed
		if(Context::get("act")!='dispEzmemberAdminLicenseAgreement' && !is_file(_XE_PATH_."/files/ezmember/.license"))
		{
			$_SESSION['EZMEMBER_FROM'] = Context::get("act");
			return $this->setRedirectURL(getNotEncodedURL("act", "dispEzmemberAdminLicenseAgreement"));
		}
	}

	/**
	 * @dispEzmemberAdminLicenseAgreement (EZMember 라이센스 동의)
	 */
	function dispEzmemberAdminLicenseAgreement(){
		
		$this->setTemplateFile("license_agreement");
		
	}

	/**
	 * @dispEzmemberAdminConfiguration(EZMember 설정 페이지)
	 */
	function dispEzmemberAdminConfiguration() {
		$oEditorModel = &getModel('editor');
		$oModuleModel = getModel('module');
		$oLayoutModel = getModel('layout');
		
		// Config 전달
		$module_info = $this->module_config;
		Context::set("module_info", $module_info);

		// 스킨 목록 전달
		$skin_list = $oModuleModel->getSkins($this->module_path);
		Context::set('skin_list',$skin_list);
		
		// 모바일 스킨 목록 전달
		$mskin_list = $oModuleModel->getSkins($this->module_path, "m.skins");
		Context::set('mskin_list', $mskin_list);
		
		// 레이아웃 목록 전달
		$layout_list = $oLayoutModel->getLayoutList();
		Context::set('layout_list', $layout_list);
		
		// 모바일 레이아웃 전달
		$mobile_layout_list = $oLayoutModel->getLayoutList(0,"M");
		Context::set('mlayout_list', $mobile_layout_list);

		// Captcha 종류 전달
		$captcha_list = array("reCAPTCHA", 'KCAPTCHA');
		Context::set('captcha_list', $captcha_list);

		$this->setTemplateFile("ezmember_configuration");
	}

	/**
	 * @dispEzmemberAdminPreference (EZMember 스킨 설정)
	 */
	function dispEzmemberAdminPreference(){
		$oModuleModel = getModel('module');
		$skin_info = $oModuleModel->loadSkinInfo($this->module_path, $this->module_config->skin);
		$skin_vars = unserialize($this->module_config->skin_vars);

		// value for skin_info extra_vars
		if(count($skin_info->extra_vars))
		{
			foreach($skin_info->extra_vars as $key => $val)
			{
				$name = $val->name;
				$type = $val->type;
				$value = $skin_vars->{$name};
				if($type=="checkbox"&&!$value) $value = array();
				$skin_info->extra_vars[$key]->value= $value;
			}
		}
		Context::set('skin_info', $skin_info);
		Context::set('skin_vars', $skin_vars);
		
		$config = $oModuleModel->getModuleConfig('ezmember');
		Context::set('module_info', unserialize($config->skin_vars));

		$this->setTemplateFile("ezmember_preference");
	}
		
	/**
	 * @dispEzmemberAdminAuthMail (인증 메일 설정)
	 */
	function dispEzmemberAdminMailTemplateList(){
		$field = 'confirm_member_account_mail';
		
		// EZMember 설정 파일을 불러온다.
		require_once($this->module_path.'ezmember.config.php');

		foreach($mail_template_list as $key=>$val){
			if(is_file(_XE_PATH_.'/files/ezmember/'.$val->file_name.'.html')) $mail_template_list[$key]->type = '사용자';
			else $mail_template_list[$key]->type = '기본값';
		}

		context::set("template_list", $mail_template_list);

		$this->setTemplateFile("ezmember_mailtemplate_list");
	}
	
	/**
	 * @dispEzmemberAdminMailTemplateEdit (인증 메일 수정)
	 */
	function dispEzmemberAdminMailTemplateEdit(){
		$oEditorModel = &getModel('editor');
		$file_name = Context::get("file_name");
		
		// 모듈 설정 가저오기
		$module_info = $this->module_config;

		// Agree1 에디터 초기화
		$option = $this->getEditorOption("no", $file_name);
		$editor = $oEditorModel->getEditor('', $option);
		
		// EZMember 설정 파일을 불러온다.
		require_once($this->module_path.'ezmember.config.php');

		foreach($mail_template_list as $key=>$val){
			if($file_name == $val->file_name) $title = $val->name;
		}
		
		if(!is_file(_XE_PATH_.'files/ezmember/'.$file_name.'.html')) $field_content = @file_get_contents($this->module_path.'/tpl/'.$file_name.'.html');
		else $field_content = @file_get_contents(_XE_PATH_.'files/ezmember/'.$file_name.'.html');
		
		Context::set("module_config", $module_info); //module_config 전달
		Context::set('editor_skin_list', $oEditorModel->getEditorSkinList());
		Context::set("editor", $editor); // editor1 변수 전달
		Context::set("field", $field); // $field 변수 전달
		Context::set("field_content", base64_encode($field_content));
		Context::set("title", $title);

		$this->setTemplateFile("ezmember_mailtemplate_edit");
	}

	/**
	 * @dispEzmemberAdminAgreementConfig (EZMember 약관 목록)
	 */
	function dispEzmemberAdminAgreementList(){		
		// EZMember 설정 파일을 불러온다.
		require_once($this->module_path.'ezmember.config.php');

		foreach($ez_agreement_list as $key=>$val){
			$field_name = 'use_step1_'.$val->file_name;

			if($this->module_config->{$field_name} == 'Enabled') $ez_agreement_list[$key]->status = '활성화';
			else $ez_agreement_list[$key]->status = '비활성화';
		}
		
		context::set("agreement_list", $ez_agreement_list);

		$this->setTemplateFile("ezmember_agreement_list");
	}
	
	/**
	 * @dispEzmemberAdminAgreementConfig (EZMember 약관 설정)
	 */
	function dispEzmemberAdminAgreementConfig(){
		$oEditorModel = &getModel('editor');
		$field = Context::get("field");
		
		// 모듈 설정 가저오기
		$module_info = $this->module_config;

		// Agree1 에디터 초기화
		$option = $this->getEditorOption("no", $field);
		$editor = $oEditorModel->getEditor('', $option);
		
		/**
		 * ISSUE 10554
		 * 약관이 DB에 들어갈 경우 오류를 유발 하므로, 파일로 별도 저장한다.
		 **ADDED**
		 **/
		$field_content = @file_get_contents(_XE_PATH_.'files/ezmember/'.$field.'.cml');
		$agreement_enabled = 'use_step1_'.$field;
		$agreement_enabled = $this->module_config->{$agreement_enabled};

		Context::set("module_config", $module_info); //module_config 전달
		Context::set('editor_skin_list', $oEditorModel->getEditorSkinList());
		Context::set("editor", $editor); // editor1 변수 전달
		Context::set("field", $field); // $field 변수 전달
		Context::set("field_content", $field_content);
		Context::set("agreement_enabled", $agreement_enabled);

		$this->setTemplateFile("ezmember_agreement");
	}

	/**
	 * @bref getEditorOption (get Editor Option)
	 **/
	function getEditorOption($args0, $args1){
		$option->primary_key_name = $args0;
		$option->content_key_name = $args1;
		$option->allow_fileupload = false;
		$option->enable_autosave = false;
		$option->enable_default_component = true;
		$option->enable_component = false;
		$option->resizable = true;
		$option->height = 240;
		$option->skin = "xpresseditor";

		return $option;
	}
	
	/**
	 * @bref dispEzmemberAdminMemberTypeConfiguration (Setting Member Types)
	 */
	function dispEzmemberAdminMembmerTypeConfiguration(){
		$oEzmemberModel = getModel('ezmember'); // get ezmember model
		$oMemberModel = getModel("member");

		// Config 전달
		$module_info = $this->module_config;
		Context::set("module_info", $module_info);
		
		$membertype_list = $oEzmemberModel->getMemberType(); // 회원 종류 전달
		$groupList = $oMemberModel->getGroups();
		
		foreach($membertype_list as $key=>$val){
			$field = 'is_'.$val->type_id.'_enable';
			$membertype_list->{$key}->enable_field_name = $field;
			$membertype_list->{$key}->is_enabled = $this->module_config->{$field};
		}

		Context::set("membertype_list", $membertype_list);
		Context::set("groupList", $groupList);

		$this->setTemplateFile("ezmember_type_configuration");
	}

	function dispEzmemberAdminStep2Configuration(){
		$oEzmemberModel = getModel('ezmember'); // get ezmember model

		// Config 전달
		$module_info = $this->module_config;
		Context::set("module_info", $module_info);

		$smsvendor_list = array('Cafe24', 'SMSMania'); // SMS 제공자 선택
		Context::set("smsvendor_list", $smsvendor_list);
	
		// 카페24인 경우 잔여 SMS 개수 구하기
		Context::set("cafe24_ramains", $oEzmemberModel->getCafe24remainSMS());

		$this->setTemplateFile("ezmember_step2_configuration");
	}

	/**
	 * Hooking member insert form
	 *
	 * @return void
	 */
	function dispMemberAdminInsert()
	{
		exit;
	}

	/**
	 * display member insert form
	 *
	 * @return void
	 */
	function dispEzmemberAdminInsert()
	{
		global $lang;
		// retrieve extend form
		$oMemberModel = getModel('member');
		$oMemberAdminView = getAdminView('member');
		$oEzmemberModel = getModel('ezmember');
	
		$oMemberAdminView->init();

		$memberInfo = Context::get('member_info');

		if(isset($memberInfo))
		{
			$memberInfo->signature = $oMemberModel->getSignature($this->memberInfo->member_srl);
		}
		Context::set('member_info', $memberInfo);

		// get an editor for the signature
		if($memberInfo->member_srl)
		{
			$oEditorModel = getModel('editor');
			$option = new stdClass();
			$option->primary_key_name = 'member_srl';
			$option->content_key_name = 'signature';
			$option->allow_fileupload = false;
			$option->enable_autosave = false;
			$option->enable_default_component = true;
			$option->enable_component = false;
			$option->resizable = false;
			$option->height = 200;
			$editor = $oEditorModel->getEditor($this->memberInfo->member_srl, $option);
			Context::set('editor', $editor);
		}

		$formTags = $oMemberAdminView->_getMemberInputTag($memberInfo, true);
		// Add Member Type
		$idx = count($formTags);
		$formTags[$idx] = new stdClass;
		$formTags[$idx]->title = $lang->member_type;
		$formTags[$idx]->name = 'member_type_id';
		$formTags[$idx]->type = 'input';
		$formTags[$idx]->inputTag = '';
		$types = $oEzmemberModel->getMemberType();
		foreach($types as $key=>$val){
			$formTags[$idx]->inputTag .= '<label class="x_inline" for=member_'.$val->type_id.'><input type="radio" name="member_type_id" id="member_'.$val->type_id.'" value="'.$val->type_id.'"';
			if($val->type_id==$memberInfo->member_type_id) $formTags[$idx]->inputTag .= ' checked';
			$formTags[$idx]->inputTag .= ' />'.$val->member_type.'</label>&nbsp;&nbsp;';
		}

		// Add Cell Phone Form Tag
		$idx = count($formTags);
		$formTags[$idx] = new stdClass;
		$formTags[$idx]->title = $lang->user_hp;
		$formTags[$idx]->type = 'input';
		$formTags[$idx]->name = 'user_hp';
		$formTags[$idx]->inputTag = "<input type='tel' id='user_hp' name='user_hp' value='".$memberInfo->user_hp."' />";
		
		// Add Business No Form Tag
		$idx = count($formTags);
		$formTags[$idx] = new stdClass;
		$formTags[$idx]->title = $lang->business_no;
		$formTags[$idx]->type = 'input';
		$formTags[$idx]->name = 'business_no';
		$formTags[$idx]->inputTag = "<input type='text' id='business_no' name='business_no' value='".$memberInfo->business_no."' />";

		// Add IPIN Virtual No
		$idx = count($formTags);
		$formTags[$idx] = new stdClass;
		$formTags[$idx]->title = $lang->virtual_no;
		$formTags[$idx]->type = 'input';
		$formTags[$idx]->name = 'virtual_no';
		$formTags[$idx]->inputTag = "<input type='hidden' id='ipin_dupinfo' name='ipin_dupinfo' value='".$memberInfo->ipin_dupinfo."' /><input type='hidden' id='virtual_no' name='virtual_no' value='".$memberInfo->virtual_no."' /><p style='padding: 5px 0;'>".$memberInfo->virtual_no.'</p>';

		Context::set('formTags', $formTags);
		$member_config = $oMemberAdminView->memberConfig;

		global $lang;
		$identifierForm = new stdClass();
		$identifierForm->title = $lang->{$member_config->identifier};
		$identifierForm->name = $member_config->identifier;
		$identifierForm->value = $memberInfo->{$member_config->identifier};
		Context::set('identifierForm', $identifierForm);
		
		// EZMember 초기화를 모듈 이름으로 알리기
		$lang->msg_update_member .= " (EZMember Extended)";
		$lang->msg_new_member .= " (EZMember Extended)";

		// 모듈 경로 호환성
		$member_module_path = str_replace('ezmember', 'member', $this->module_path);
		$template_path = sprintf("%stpl/", $member_module_path);
		$this->setTemplatePath($template_path);
		$this->setTemplateFile('insert_member');
	}

	/**
	 * display EZMember Info
	 *
	 * @return void
	 */
	function dispEzmemberAdminAboutProgram()
	{
		$programInfo = array();
		
		require_once($this->module_path."/ezmember.config.php");

		// Insert Data
		$field = new stdClass;
		$field->name = '모듈명';
		$field->value = 'EZMember R2';
		$programInfo[] = $field;

		// Insert Data
		$field = new stdClass;
		$field->name = '버전';
		$field->value = Version;
		$programInfo[] = $field;

		// Insert Data
		$field = new stdClass;
		$field->name = '라이센스';
		$field->value = 'MIT License';
		$programInfo[] = $field;

		// Insert Data
		$field = new stdClass;
		$field->name = '제작자';
		$field->value = 'AST Sinoko';
		$programInfo[] = $field;

		// Insert Data
		$field = new stdClass;
		$field->name = 'License Material';
		$field->value = 'KCaptcha (http://www.captcha.ru)';
		$field->value .= '<br/>reCAPTCHA (https://www.google.com/recaptcha)';
		$field->value .= '<br/>나이스신용평가정보원 (http://www.nice.co.kr)';
		$field->value .= '<br/>(주)미직스 (http://www.migix.jp)';
		$programInfo[] = $field;

		Context::set("programInfo", $programInfo);

		$this->setTemplateFile("about_ezmember");
	}
}
